
/**
 * Created by IntelliJ IDEA.
 * User: naeem
 * Date: Mar 24, 2004
 * Time: 9:15:49 AM
 */

/**
 * This is the queue that is used for reader and writer threads
 */
public class Queue {
    /**
     * If the queue is empty
     *
     * @return if the queue is empty
     */
    public boolean isEmpty() {
        return !full && (head == tail);
    }

    /**
     * If the queue is full
     *
     * @return if the queue is full
     */
    public boolean isFull() {
        return full;
    }

    /**
     * Adding element to queue or produce
     *
     * @param element newly produced element
     * @throws QueueIsFullException queue must not be full
     */
    public void Enqueue(int element) throws QueueIsFullException {
        if (isFull())
            throw new QueueIsFullException(element);

        mynums[tail++] = element;
        tail %= SIZE;

        if (head == tail)
            full = true;
    }

    /**
     * Removing element to queue or consume
     *
     * @return Consumed item
     * @throws QueueIsEmptyException queue must not be empty
     */
    public int Dequeue() throws QueueIsEmptyException {
        if (isEmpty())
            throw new QueueIsEmptyException();

        full = false;
        int temp = mynums[head++];
        head %= SIZE;

        return temp;
    }

    /**
     * If the queue is in except condition
     *
     * @return if queue is in except condition
     */
    public boolean isExcept() {
        return except;
    }

    /**
     * Sets the queue in except condition
     */
    public void setExcept() {
        except = true;
    }

    /**
     * The size of the queue
     */
    final private int SIZE = 50;

    /**
     * If the queue is in the except condition (if reader tries to read from empty queue
     * or writer try to write in full one)
     */
    private boolean except = false;

    /**
     * We want not to have empty cell so keeping track of previous condition is essential
     */
    private boolean full = false;

    /**
     * Tail and head of the queue
     */
    private int head = 0, tail = 0;

    /**
     * Queue itself!
     */
    private int[] mynums = new int[SIZE];
}
