
import java.net.*;
import java.io.*;

/**
 * Created by IntelliJ IDEA.
 * User: naeem
 * Date: Mar 24, 2004
 * Time: 6:51:51 PM
 */

/**
 * The client side of one client-server downloading program
 */
public class ClientSide {

    /**
     * This function is main!
     *
     * @param args command line parameters
     */
    public static void main(String[] args) throws IOException {
        new ClientSide( PUT);
    }

    /**
     * This is the Constructor! getting pattern and stablishing connection to server
     *
     * @throws IOException in case of IOError
     */
    public ClientSide( String putplc) throws IOException {
        System.out.print( "Please enter your pattern: ");
        System.out.flush();
        BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
        pat = console.readLine();
        put = putplc;
        socket = new Socket(InetAddress.getByName(null), ServerSide.PORT);
        shakeHand();
    }

    /**
     * Following protocol and stablishing input and output streams
     *
     * @throws IOException in case of IOError
     */
    private void shakeHand() throws IOException {
        try {
            ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
//                    new BufferedOutputStream(socket.getOutputStream()));
            ObjectInputStream in = new ObjectInputStream(//socket.getInputStream());
                    new BufferedInputStream(socket.getInputStream()));

            out.writeObject("HELLO");
            out.writeObject(pat);
            out.flush();

            try {
                Integer numfile = (Integer) in.readObject();
                int i;

                if( numfile.intValue() > 0)
                {
                    for (i = 0; i < numfile.intValue(); i++) {
                        System.out.print((((Integer) in.readObject()).intValue() + 1) + " ");
                        System.out.println((String) in.readObject());
                    }

                    int choice = getChoice() - 1;

                    if (choice < 0 || choice >= numfile.intValue())
                        choice = -1;

                    out.writeObject(new Integer(choice));
                    out.flush();

                    if( choice != -1)
                        getFile(in);
                }else
                    System.out.println( "There is no file matching this pattern.");
            } catch (ClassNotFoundException cnfe) {
                System.out.println("The read object must be String! " + cnfe.getMessage());
            } catch (ClassCastException cce) {
                System.out.println("The read object must be String! " + cce.getMessage());
            }
        } finally {
            socket.close();
        }
    }

    /**
     * Simply gets an integer
     *
     * @return read integer
     * @throws IOException in case of IOError
     */
    private int getChoice() throws IOException {
        System.out.print("What is your choice: ");
        System.out.flush();
        BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
        String str = console.readLine();
        return Integer.parseInt(str);
    }

    /**
     * Fetching file from stream. At the other end server sends file
     *
     * @param in input socket stream
     * @throws IOException in case of IOError
     */
    private void getFile(ObjectInputStream in) throws IOException {
        try {
            String name = (String) in.readObject();
            System.out.print( name + ": ");
            long size = ((Long) in.readObject()).longValue();
            System.out.println( size + " Bytes");

            FileOutputStream file = new FileOutputStream( put + name);

            for( int i = 0; i < size; i++){
//                int temp = ((Integer)in.readObject()).intValue();
                int temp = in.readByte();
                file.write(temp);
            }

            file.close();
        } catch (ClassNotFoundException cnfe) {
            System.out.println("Protocol is disturbed! " + cnfe.getMessage());
            return;
        } catch (ClassCastException cce) {
            System.out.println("Protocol is disturbed! " + cce.getMessage());
            return;
        }
    }

    /**
     * The put place of files in the system
     */
    private String put;

    /**
     * The socket that has stablished connection to server
     */
    private Socket socket;

    /**
     * This field contains pattern
     */
    private String pat;

    /**
     * The static field that contains the put place address
     */
    private static final String PUT = "../Put/";
}
